# RpiLedBars

## TODO

### backend

#### Toolchain

- [ ] build raspberrypi toolchain : 
  - https://tttapa.github.io/Pages/Raspberry-Pi/C++-Development/Building-The-Toolchain.html
  - https://medium.com/@stonepreston/how-to-cross-compile-a-cmake-c-application-for-the-raspberry-pi-4-on-ubuntu-20-04-bac6735d36df
- [ ] create a dockerized dev env
- [ ] use CMake to crosscompile
- [ ] use gdb and valgrind to debug and itegrate in vscode :
  - https://code.visualstudio.com/docs/cpp/configure-intellisense-crosscompilation

#### Code

- [ ] move midi specific computing from param
- [ ] Use Json : https://github.com/json-c/json-c
- [ ] Midi note and clock sync
- [ ] Transitions

### frontend

- [ ] use Vue.js
- [ ] automate deployment
- [ ] define protocol

### hardware

- [ ] add button to switch AP

## Protocol

### From frontend to backend
| msg | desc |
| --- | ---- |
| c   |      |
|     |      |

### From backend to frontend