/** @file selector.h
 *  @brief This module contains continuous tasks for cava (spectrum analyzer) comunication
 */
#if !defined(__SELECTOR_TASK_H__)
#define __SELECTOR_TASK_H__

/***************************************************************************************************
 * Includes
 **************************************************************************************************/

/***************************************************************************************************
 * Preprocessor Constants and Macros
 **************************************************************************************************/

/***************************************************************************************************
 * Type and Contant Definitions
 **************************************************************************************************/

/***************************************************************************************************
 * Global Variables
 **************************************************************************************************/

/***************************************************************************************************
 * External Function Prototypes
 **************************************************************************************************/

/**
 * @brief Start selector listener module
 **/
void selector_start();

void selector_stop();

#endif /* __SELECTOR_TASK_H__ */